#ifndef CORE_TESTS_HPP
#define CORE_TESTS_HPP

[[noreturn]] void testInvalidAllocate();
[[noreturn]] void testInvalidReallocate();
[[noreturn]] void testPostCanary();
[[noreturn]] void testPreCanary();
[[noreturn]] void testPreCanaryNew();
[[noreturn]] void testPreCanaryNewArray();
void testArray();
void testArrayList(bool light);
void testBitArray();
void testBox();
void testBuffer(bool light);
void testClock(bool light);
void testColor();
void testComponents();
void testFile();
void testFrustum();
void testHashMap(bool light);
void testHashedString();
void testInteractiveTerminal();
void testList(bool light);
void testMath();
void testMatrix();
void testPlane();
void testQuaternion();
void testQueue();
void testRandom(bool light);
void testReadLine();
void testTerminal(bool tty);
void testTest();
void testThread();
void testUnicode();
void testUniquePointer();
void testUtility();
void testVector();
void testView();

#endif
